<?php

/**
 * Implements hook_ca_predicate().
 */
function uc_shipwire_ca_predicate() {
  $enabled = variable_get('uc_quote_enabled', array());

  $predicates = array(
    'uc_shipwire_get_quote' => array(
      '#title' => t('Shipping quote from Shipwire'),
      '#trigger' => 'get_quote_from_shipwire',
      '#class' => 'uc_shipwire',
      '#status' => $enabled['shipwire'],
      '#actions' => array(
        array(
          '#name' => 'uc_quote_action_get_quote',
          '#title' => t('Fetch a shipping quote'),
          '#argument_map' => array(
            'order' => 'order',
            'method' => 'method',
          ),
        ),
      ),
    ),
    'uc_shipwire_submit_order' => array(
      '#title' => t('Submit order to shipwire'),
      '#trigger' => 'uc_payment_entered',
      '#class' => 'uc_shipwire',
      '#status' => $enabled['shipwire'],
      '#conditions' => array(
        '#operator' => 'AND',
        '#conditions' => array(
          array(
            '#name' => 'uc_payment_condition_order_balance',
            '#title' => t('If the balance is less than or equal to $0.00.'),
            '#argument_map' => array(
              'order' => 'order',
            ),
            '#settings' => array(
              'negate' => FALSE,
              'balance_comparison' => 'less_equal',
            ),
          ),
          array(
            '#name' => 'uc_quote_condition_order_shipping_method',
            '#title' => t('Order to be shipped by Shipwire'),
            '#argument_map' => array(
              'order' => 'order',
            ),
            '#settings' => array(
              'negate' => FALSE,
              'method' => 'shipwire',
            ),
          ),
        ),
      ),
      '#actions' => array(
        array(
          '#name' => 'uc_shipwire_order',
          '#title' => t('Submit order to Shipwire'),
          '#argument_map' => array(
            'order' => 'order',
          ),
        ),
      ),
    ),
  );


  return $predicates;
}

/**
 * Implements hook_ca_action().
 */
function uc_shipwire_ca_action() {
  $order_arg = array(
    '#entity' => 'uc_order',
    '#title' => t('Order'),
  );

  $actions['uc_shipwire_order'] = array(
    '#title' => t('Submit order to Shipwire'),
    '#category' => t('Shipwire'),
    '#callback' => 'uc_shipwire_action_order',
    '#arguments' => array(
      'order' => $order_arg,
    ),
  );

  return $actions;
}
